﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using cipeinet;
using System.IO;

namespace EasyIntegrator_Gift_Card_C_Sharp_Demo
{
    public partial class Form1 : Form
    {
        EasyIntegrator easyIntegrator = new cipeinet.EasyIntegrator();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_load(object sender, EventArgs e)
        {
            if (File.Exists("setup1.txt"))
            {
                TextBox_Setup.Text = System.IO.File.ReadAllText("setup1.txt");
            }
            else
            {
                System.IO.File.WriteAllText(@"setup1.txt", "");
            }        
        }

        private void Button_Setup_Click(object sender, EventArgs e)
        {
            TextBox_Setup.Text = easyIntegrator.Setup(TextBox_Setup.Text);
            System.IO.File.WriteAllText("setup1.txt", TextBox_Setup.Text);
        }

        private void Button_GiftBalance_Click(object sender, EventArgs e)
        {
            easyIntegrator.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_Invoice.Text;
            if (easyIntegrator.GiftBalance())
            {
                PrintReceipt();
            }
        }

        private void Button_AddBalance_Click(object sender, EventArgs e)
        {
            easyIntegrator.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_Invoice.Text;
            easyIntegrator.transFields.AmountTotal = double.Parse(TextBox_Amount.Text);
            if (easyIntegrator.GiftAddValue())
            {
                PrintReceipt();
            }
        }

        private void Button_Redeem_Click(object sender, EventArgs e)
        {
            easyIntegrator.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_Invoice.Text;
            easyIntegrator.transFields.AmountTotal = double.Parse(TextBox_Amount.Text);
            if (easyIntegrator.GiftRedeem())
            {
                PrintReceipt();
            }
        }

        private void Button_GiftRedeemMax_Click(object sender, EventArgs e)
        {
            easyIntegrator.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_Invoice.Text;
            easyIntegrator.transFields.AmountTotal = double.Parse(TextBox_Amount.Text);
            if (easyIntegrator.GiftRedeemMax())
            {
                PrintReceipt();
            }
        }

        private void PrintReceipt()
        {
            TextBox_Receipt.Clear();
            TextBox_Receipt.AppendText(string.Concat(DateTime.Now.ToString(), "\r\n\r\n"));
            TextBox_Receipt.AppendText(string.Concat("Cashier: ", easyIntegrator.transFields.Cashier, "\r\n"));
            TextBox_Receipt.AppendText(string.Concat("Trans Type: ", easyIntegrator.resultsFields.TransactionType, "\r\n\r\n"));
            TextBox_Receipt.AppendText(string.Concat("Card: ", easyIntegrator.resultsFields.MaskedAccount, "\r\n"));
            TextBox_Receipt.AppendText(string.Concat("Billing Name: ",easyIntegrator.resultsFields.BillingName,"\r\n"));
            if (easyIntegrator.transFields.AmountTotal == 0)
            {
                TextBox_Receipt.AppendText(string.Concat("Amount Added/Redeemed: N/A \r\n"));
            }
            else
            {
                TextBox_Receipt.AppendText(string.Concat("Amount Added/Redeemed: ", easyIntegrator.transFields.AmountTotal, "\r\n"));
            }
            TextBox_Receipt.AppendText(string.Concat("Approval Code: ", easyIntegrator.resultsFields.ApprovalNumberResult, "\r\n"));
            TextBox_Receipt.AppendText(string.Concat("TransID: ", easyIntegrator.resultsFields.UniqueTransID,"\r\n\r\n"));
            TextBox_Receipt.AppendText(string.Concat("Current Balance: ",easyIntegrator.resultsFields.AmountBalance,"\r\n"));
        }      
    }
}
